3 # Copyright (C) 2017 Luis R. Rodriguez <mcgrof@kernel.org>
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of the GNU General Public License as published by the Free
7 # Software Foundation; either version 2 of the License, or at your option any
8 # later version; or, when distributed separately from the Linux kernel or
9 # when incorporated into other software packages, subject to the following
12 # This program is free software; you can redistribute it and/or modify it
13 # under the terms of copyleft-next (version 0.3.1 or later) as published
14 # at http://copyleft-next.org/.
16 # This is a stress test script for kmod, the kernel module loader. It uses
17 # test_kmod which exposes a series of knobs for the API for us so we can
18 # tweak each test in userspace rather than in kernelspace.
20 # The way kmod works is it uses the kernel's usermode helper API to eventually
21 # call /sbin/modprobe. It has a limit of the number of concurrent calls
22 # possible. The kernel interface to load modules is request_module(), however
23 # mount uses get_fs_type(). Both behave slightly differently, but the
24 # differences are important enough to test each call separately. For this
25 # reason test_kmod starts by providing tests for both calls.
27 # The test driver test_kmod assumes a series of defaults which you can
28 # override by exporting to your environment prior running this script.
29 # For instance this script assumes you do not have xfs loaded upon boot.
30 # If this is false, export DEFAULT_KMOD_FS="ext4" prior to running this
31 # script if the filesystem module you don't have loaded upon bootup
32 # is ext4 instead. Refer to allow_user_defaults() for a list of user
33 # override variables possible.
35 # You'll want at least 4 GiB of RAM to expect to run these tests
36 # without running out of memory on them. For other requirements refer
42 TEST_DRIVER
="test_${TEST_NAME}"
43 TEST_DIR
=$
(dirname $0)
47 # TEST_ID:TEST_COUNT:ENABLED
49 # TEST_ID: is the test id number
50 # TEST_COUNT: number of times we should run the test
51 # ENABLED: 1 if enabled, 0 otherwise
53 # Once these are enabled please leave them as-is. Write your own test,
54 # we have tons of space.
56 ALL_TESTS
="$ALL_TESTS 0002:3:1"
57 ALL_TESTS
="$ALL_TESTS 0003:1:1"
58 ALL_TESTS
="$ALL_TESTS 0004:1:1"
59 ALL_TESTS
="$ALL_TESTS 0005:10:1"
60 ALL_TESTS
="$ALL_TESTS 0006:10:1"
61 ALL_TESTS
="$ALL_TESTS 0007:5:1"
62 ALL_TESTS
="$ALL_TESTS 0008:150:1"
63 ALL_TESTS
="$ALL_TESTS 0009:150:1"
65 # Kselftest framework requirement - SKIP code is 4.
70 if [ ! -d $DIR ]; then
71 echo "$0: $DIR not present" >&2
72 echo "You must have the following enabled in your kernel:" >&2
73 cat $TEST_DIR/config
>&2
78 function allow_user_defaults
()
80 if [ -z $DEFAULT_KMOD_DRIVER ]; then
81 DEFAULT_KMOD_DRIVER
="test_module"
84 if [ -z $DEFAULT_KMOD_FS ]; then
88 if [ -z $PROC_DIR ]; then
89 PROC_DIR
="/proc/sys/kernel/"
92 if [ -z $MODPROBE_LIMIT ]; then
97 DIR
="/sys/devices/virtual/misc/${TEST_DRIVER}0/"
100 if [ -z $DEFAULT_NUM_TESTS ]; then
101 DEFAULT_NUM_TESTS
=150
104 MODPROBE_LIMIT_FILE
="${PROC_DIR}/kmod-limit"
109 if ! which modprobe
2> /dev
/null
> /dev
/null
; then
110 echo "$0: You need modprobe installed" >&2
114 if ! which kmod
2> /dev
/null
> /dev
/null
; then
115 echo "$0: You need kmod installed" >&2
119 # kmod 19 has a bad bug where it returns 0 when modprobe
120 # gets called *even* if the module was not loaded due to
121 # some bad heuristics. For details see:
123 # A work around is possible in-kernel but its rather
125 KMOD_VERSION
=$
(kmod
--version |
awk '{print $3}')
126 if [[ $KMOD_VERSION -le 19 ]]; then
127 echo "$0: You need at least kmod 20" >&2
128 echo "kmod <= 19 is buggy, for details see:" >&2
129 echo "http://git.kernel.org/cgit/utils/kernel/kmod/kmod.git/commit/libkmod/libkmod-module.c?id=fd44a98ae2eb5eb32161088954ab21e58e19dfc4" >&2
134 if [ $uid -ne 0 ]; then
135 echo $msg must be run as root
>&2
140 function load_req_mod
()
142 trap "test_modprobe" EXIT
144 if [ ! -d $DIR ]; then
145 # Alanis: "Oh isn't it ironic?"
146 modprobe
$TEST_DRIVER
152 echo "Test completed"
158 # kmod calls modprobe and upon of a module not found
159 # modprobe returns just 1... However in the kernel we
160 # *sometimes* see 256...
181 echo MODULE_NOT_FOUND
;;
196 config_set_test_case_driver
()
198 if ! echo -n 1 >$DIR/config_test_case
; then
199 echo "$0: Unable to set to test case to driver" >&2
204 config_set_test_case_fs
()
206 if ! echo -n 2 >$DIR/config_test_case
; then
207 echo "$0: Unable to set to test case to fs" >&2
214 if ! echo -n $1 >$DIR/config_num_threads
; then
215 echo "$0: Unable to set to number of threads" >&2
220 config_get_modprobe_limit
()
222 if [[ -f ${MODPROBE_LIMIT_FILE} ]] ; then
223 MODPROBE_LIMIT
=$
(cat $MODPROBE_LIMIT_FILE)
228 config_num_thread_limit_extra
()
230 MODPROBE_LIMIT
=$
(config_get_modprobe_limit
)
231 let EXTRA_LIMIT
=$MODPROBE_LIMIT+$1
232 config_num_threads
$EXTRA_LIMIT
235 # For special characters use printf directly,
236 # refer to kmod_test_0001
239 if ! echo -n $1 >$DIR/config_test_driver
; then
240 echo "$0: Unable to set driver" >&2
247 if ! echo -n $1 >$DIR/config_test_fs
; then
248 echo "$0: Unable to set driver" >&2
255 cat $DIR/config_test_driver
258 config_get_test_result
()
265 if ! echo -n "1" >"$DIR"/reset; then
266 echo "$0: reset should have worked" >&2
273 echo "----------------------------------------------------"
275 echo "----------------------------------------------------"
280 if ! echo -n "1" >"$DIR"/trigger_config
2>/dev
/null
; then
281 echo "$1: FAIL - loading should have worked"
285 echo "$1: OK! - loading kmod test"
288 config_trigger_want_fail
()
290 if echo "1" > $DIR/trigger_config
2>/dev
/null
; then
291 echo "$1: FAIL - test case was expected to fail"
295 echo "$1: OK! - kmod test case failed as expected"
298 config_expect_result
()
300 RC
=$
(config_get_test_result
)
301 RC_NAME
=$
(errno_val_to_name
$RC)
304 ERRNO
=$
(errno_name_to_val
$ERRNO_NAME)
306 if [[ $ERRNO_NAME = "-ERR_ANY" ]]; then
307 if [[ $RC -ge 0 ]]; then
308 echo "$1: FAIL, test expects $ERRNO_NAME - got $RC_NAME ($RC)" >&2
312 elif [[ $RC != $ERRNO ]]; then
313 echo "$1: FAIL, test expects $ERRNO_NAME ($ERRNO) - got $RC_NAME ($RC)" >&2
317 echo "$1: OK! - Return value: $RC ($RC_NAME), expected $ERRNO_NAME"
320 kmod_defaults_driver
()
323 modprobe
-r $DEFAULT_KMOD_DRIVER
324 config_set_driver
$DEFAULT_KMOD_DRIVER
330 modprobe
-r $DEFAULT_KMOD_FS
331 config_set_fs
$DEFAULT_KMOD_FS
332 config_set_test_case_fs
335 kmod_test_0001_driver
()
341 printf '\000' >"$DIR"/config_test_driver
342 config_trigger
${FUNCNAME[0]}
343 config_expect_result
${FUNCNAME[0]} MODULE_NOT_FOUND
352 printf '\000' >"$DIR"/config_test_fs
353 config_trigger
${FUNCNAME[0]}
354 config_expect_result
${FUNCNAME[0]} -EINVAL
359 kmod_test_0001_driver
363 kmod_test_0002_driver
()
365 NAME
="nope-$DEFAULT_KMOD_DRIVER"
368 config_set_driver
$NAME
370 config_trigger
${FUNCNAME[0]}
371 config_expect_result
${FUNCNAME[0]} MODULE_NOT_FOUND
376 NAME
="nope-$DEFAULT_KMOD_FS"
380 config_trigger
${FUNCNAME[0]}
381 config_expect_result
${FUNCNAME[0]} -EINVAL
386 kmod_test_0002_driver
394 config_trigger
${FUNCNAME[0]}
395 config_expect_result
${FUNCNAME[0]} SUCCESS
402 config_trigger
${FUNCNAME[0]}
403 config_expect_result
${FUNCNAME[0]} SUCCESS
409 config_trigger
${FUNCNAME[0]}
410 config_expect_result
${FUNCNAME[0]} SUCCESS
416 config_trigger
${FUNCNAME[0]}
417 config_expect_result
${FUNCNAME[0]} SUCCESS
429 MODPROBE_LIMIT
=$
(config_get_modprobe_limit
)
430 let EXTRA
=$MODPROBE_LIMIT/6
431 config_num_thread_limit_extra
$EXTRA
432 config_trigger
${FUNCNAME[0]}
433 config_expect_result
${FUNCNAME[0]} SUCCESS
439 MODPROBE_LIMIT
=$
(config_get_modprobe_limit
)
440 let EXTRA
=$MODPROBE_LIMIT/4
441 config_num_thread_limit_extra
$EXTRA
442 config_trigger
${FUNCNAME[0]}
443 config_expect_result
${FUNCNAME[0]} SUCCESS
450 echo "TEST_ID x NUM_TEST"
451 echo "TEST_ID: Test ID"
452 echo "NUM_TESTS: Number of recommended times to run the test"
454 echo "0001 x $(get_test_count 0001) - Simple test - 1 thread for empty string"
455 echo "0002 x $(get_test_count 0002) - Simple test - 1 thread for modules/filesystems that do not exist"
456 echo "0003 x $(get_test_count 0003) - Simple test - 1 thread for get_fs_type() only"
457 echo "0004 x $(get_test_count 0004) - Simple test - 2 threads for get_fs_type() only"
458 echo "0005 x $(get_test_count 0005) - multithreaded tests with default setup - request_module() only"
459 echo "0006 x $(get_test_count 0006) - multithreaded tests with default setup - get_fs_type() only"
460 echo "0007 x $(get_test_count 0007) - multithreaded tests with default setup test request_module() and get_fs_type()"
461 echo "0008 x $(get_test_count 0008) - multithreaded - push kmod_concurrent over max_modprobes for request_module()"
462 echo "0009 x $(get_test_count 0009) - multithreaded - push kmod_concurrent over max_modprobes for get_fs_type()"
467 NUM_TESTS
=$
(grep -o ' ' <<<"$ALL_TESTS" |
grep -c .
)
468 let NUM_TESTS
=$NUM_TESTS+1
469 MAX_TEST
=$
(printf "%04d\n" $NUM_TESTS)
470 echo "Usage: $0 [ -t <4-number-digit> ] | [ -w <4-number-digit> ] |"
471 echo " [ -s <4-number-digit> ] | [ -c <4-number-digit> <test- count>"
472 echo " [ all ] [ -h | --help ] [ -l ]"
474 echo "Valid tests: 0001-$MAX_TEST"
476 echo " all Runs all tests (default)"
477 echo " -t Run test ID the number amount of times is recommended"
478 echo " -w Watch test ID run until it runs into an error"
479 echo " -s Run test ID once"
480 echo " -c Run test ID x test-count number of times"
481 echo " -l List all test ID list"
482 echo " -h|--help Help"
484 echo "If an error every occurs execution will immediately terminate."
485 echo "If you are adding a new test try using -w <test-ID> first to"
486 echo "make sure the test passes a series of tests."
490 echo "${TEST_NAME}.sh -- executes all tests"
491 echo "${TEST_NAME}.sh -t 0008 -- Executes test ID 0008 number of times is recommended"
492 echo "${TEST_NAME}.sh -w 0008 -- Watch test ID 0008 run until an error occurs"
493 echo "${TEST_NAME}.sh -s 0008 -- Run test ID 0008 once"
494 echo "${TEST_NAME}.sh -c 0008 3 -- Run test ID 0008 three times"
503 if ! [[ $1 =~
$re ]]; then
508 function get_test_count
()
511 TEST_DATA
=$
(echo $ALL_TESTS |
awk '{print $'$1'}')
512 LAST_TWO
=${TEST_DATA#*:*}
516 function get_test_enabled
()
519 TEST_DATA
=$
(echo $ALL_TESTS |
awk '{print $'$1'}')
520 echo ${TEST_DATA#*:*:}
523 function run_all_tests
()
525 for i
in $ALL_TESTS ; do
527 ENABLED
=$
(get_test_enabled
$TEST_ID)
528 TEST_COUNT
=$
(get_test_count
$TEST_ID)
529 if [[ $ENABLED -eq "1" ]]; then
530 test_case
$TEST_ID $TEST_COUNT
537 if [ $# -ne 3 ]; then
541 echo "Running test: $2 - run #$1"
544 function watch_case
()
549 if [ $# -eq 1 ]; then
551 watch_log
$i ${TEST_NAME}_test_
$1
563 NUM_TESTS
=$DEFAULT_NUM_TESTS
564 if [ $# -eq 2 ]; then
569 while [ $i -lt $NUM_TESTS ]; do
571 watch_log
$i ${TEST_NAME}_test_
$1 noclear
572 RUN_TEST
=${TEST_NAME}_test_
$1
578 function parse_args
()
580 if [ $# -eq 0 ]; then
583 if [[ "$1" = "all" ]]; then
585 elif [[ "$1" = "-w" ]]; then
588 elif [[ "$1" = "-t" ]]; then
591 test_case
$1 $
(get_test_count
$1)
592 elif [[ "$1" = "-c" ]]; then
597 elif [[ "$1" = "-s" ]]; then
600 elif [[ "$1" = "-l" ]]; then
602 elif [[ "$1" = "-h" ||
"$1" = "--help" ]]; then
614 trap "test_finish" EXIT